#include <stdio.h>
#include <cgi/util.c>

int year = 0, month = 0, date = 0, leapyear;
int cl, x;
char *name, *value;
int ndays[13] = {365, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

void cexit (int status) {
   printf("</BODY>\n");
   printf("</HTML>\n");
   exit (status);
}

void initialize() {
   printf("Content-type: text/html%c%c",10,10);

   if (strcmp(getenv("REQUEST_METHOD"),"POST")) {
      printf("This script should be referenced with a METHOD of POST.\n");
      cexit (1);
   }

   if(strcmp(getenv("CONTENT_TYPE"),"application/x-www-form-urlencoded")) {
       printf("This script can only be used to decode form results. \n");
       cexit (1);
   }

   cl = atoi(getenv("CONTENT_LENGTH"));

   printf("<HTML>\n");
   printf("<HEAD><TITLE>HTML Calendar</TITLE></HEAD>\n");
   printf("<BODY>\n");
}

void getValues() {
   int i, val;

   for (i=0; cl && (!feof(stdin)); i++) {
      value = fmakeword(stdin,'&',&cl);
      plustospace(value);
      unescape_url(value);
      name = makeword(value,'=');
      if (!strcmp(name,"month")) {
         val = atoi(value);
         month = val;
      }
      if (!strcmp(name,"year")) {
         val = atoi(value);
         year = val;
      }
      if (!strcmp(name,"date")) {
         val = atoi(value);
         date = val;
      }
   }

   if (month == 0) date = 0;

   if ((year <= 0) || (year >= 10000)) {
      printf("<SCRIPT>alert(\"Year must be between 1 and 9999\")</SCRIPT>");
      cexit (1);
   }

   if (year <= 1752) leapyear = ((year % 4) ? 0 : 1);
   else if (year % 400 == 0) leapyear = 1;
   else if (year % 100 == 0) leapyear = 0;
   else if (year % 4 == 0) leapyear = 1;
   else leapyear = 0;

   if (leapyear) { ndays[0] = 366; ndays[2] = 29; }

   if (year == 1752) { ndays[0] = 355; ndays[9] = 19; }

   if ( (month > 0) && ((date < 0) || (date > ndays[month])) ) {
      if (!((month == 9) && (year == 1752) && (date >= 0) && (date <= 30))) {
         printf("<SCRIPT>alert(\"Invalid date\")</SCRIPT>");
         cexit (1);
      }
   }
}

int findDay ( int year , int month , int date ) {
   int tdays;
   int i;

   if (year < 1752) {
      tdays = 5;
      year--;
      tdays += year + (year / 4);
      year++;
   } else if (year == 1752) {
      tdays = 2;
   } else {
      tdays = 0;
      year -= 1753;
      tdays += year + (year / 4) - (year / 100) + (year / 400);
      year += 1753;
   }
   for (i=1; i<month; i++) tdays += ndays[i];
   if ( (year == 1752) && (month == 9) ) {
      if (date <= 2) tdays += date;
      else if (date <= 13) return (-1);
      else tdays += date - 11;
   } else tdays += date;
   tdays %= 7;
   return (tdays);
}

void getDayName (char *dname, int day) {
   switch (day) {
      case 0: sprintf(dname, "Sun"); break;
      case 1: sprintf(dname, "Mon"); break;
      case 2: sprintf(dname, "Tue"); break;
      case 3: sprintf(dname, "Wed"); break;
      case 4: sprintf(dname, "Thu"); break;
      case 5: sprintf(dname, "Fri"); break;
      case 6: sprintf(dname, "Sat"); break;
      default: sprintf(dname, "???");
   }
}

void getMonthName (char *mname, int month) {
   switch (month) {
      case 1: sprintf(mname, "January"); break;
      case 2: sprintf(mname, "February"); break;
      case 3: sprintf(mname, "March"); break;
      case 4: sprintf(mname, "April"); break;
      case 5: sprintf(mname, "May"); break;
      case 6: sprintf(mname, "June"); break;
      case 7: sprintf(mname, "July"); break;
      case 8: sprintf(mname, "August"); break;
      case 9: sprintf(mname, "September"); break;
      case 10: sprintf(mname, "October"); break;
      case 11: sprintf(mname, "November"); break;
      case 12: sprintf(mname, "December"); break;
      default: sprintf(mname, "???"); break;
   }
}

void printDate() {
   int day;
   char mname[20], dname[20];

   day = findDay(year, month, date);
   getDayName(dname, day); getMonthName(mname, month);
   printf("<SPACER TYPE=vertical SIZE=20>\n");
   printf("<FONT SIZE=\"+2\">\n");
   printf("<B>Date:</B> %s %d, %d <SPACER TYPE=horizontal SIZE=10><B>Day:</B> %s\n",
           mname, date, year, dname);
   printf("</FONT>\n");
}

void printMonth( int flag ) {
   char mname[20];
   int i, j, nd, day, row;
   char array[5][7][3];

   getMonthName(mname, month);
   nd = ndays[month];
   if ( (year == 1752) && (month == 9) ) {
      sprintf(array[0][0], ""); sprintf(array[0][1], "");
      sprintf(array[0][2], "1"); sprintf(array[0][3], "2");
      sprintf(array[0][4], "14"); sprintf(array[0][5], "15"); sprintf(array[0][6], "16");
      for (i=0; i<=6; i++) {
         sprintf(array[1][i], "%d", i + 17);
         sprintf(array[2][i], "%d", i + 24);
         sprintf(array[3][i], ""); sprintf(array[4][i], "");
      }
   } else {
      row = 0; day = findDay(year, month, 1);
      for (i=0; i<day; i++) sprintf(array[0][i], "");
      for (i=1; i<=nd; i++) {
         sprintf(array[row][day], "%d", i);
         day++;
         if (day == 7) {
            day = 0; row++; if (row == 5) row = 0;
         }
      }
      if (row == 4) for (i=day; i<7; i++) sprintf(array[4][i], "");
   }
   if (flag) printf("<SPACER TYPE=vertical SIZE=20>\n");
   printf("<TABLE BORDER=3 CELLPADDING=0>\n");
   printf("<TR><TH COLSPAN=7 BGCOLOR=#004466><FONT COLOR=yellow FACE=HELVETICA>%s", mname);
   if (flag) printf(", %d",year);
   printf("</FONT></TH>\n");
   printf("<TR></TR><TR>");
   printf("<TH align=right><FONT COLOR=red FACE=HELVETICA>S&nbsp;</FONT></TH>\n");
   printf("<TH align=right><FONT FACE=HELVETICA>M&nbsp;</FONT></TH>\n");
   printf("<TH align=right><FONT FACE=HELVETICA>Tu&nbsp;</FONT></TH>\n");
   printf("<TH align=right><FONT FACE=HELVETICA>W&nbsp;</FONT></TH>\n");
   printf("<TH align=right><FONT FACE=HELVETICA>Th&nbsp;</FONT></TH>\n");
   printf("<TH align=right><FONT FACE=HELVETICA>F&nbsp;</FONT></TH>\n");
   printf("<TH align=right><FONT FACE=HELVETICA>S&nbsp;</FONT></TH>\n");
   for (i=0; i<=4; i++) {
      printf("<TR><TD ALIGN=right><FONT COLOR=red FACE=HELVETICA>&nbsp;&nbsp;%s&nbsp;</FONT></TD>\n", array[i][0]);
      for (j=1; j<=6; j++) printf("<TD ALIGN=right><FONT FACE=HELVETICA>&nbsp;&nbsp;%s&nbsp;</FONT></TD>\n", array[i][j]);
   }
   printf("</TABLE>\n");
}

void printYear() {
   printf("<TABLE BORDER=5 CELLPADDING=4>\n");
   printf("<TR><TH COLSPAN=3 BGCOLOR=#333333><BIG><BIG><BIG><BIG><FONT COLOR=cyan FACE=HELVETICA>%d</FONT></BIG></BIG></BIG></BIG>\n", year);
   for (month=1; month<=12; month++) {
      if (month & 1 == 1) printf("<TR>");
      printf("<TD>");
      printMonth(0);
   }
   printf("</TABLE>\n");
}

void printCal () {
   printf("<CENTER>\n");
   if (month == 0) printYear();
   else if (date == 0) printMonth(1);
   else printDate();
   printf("</CENTER>\n");
}

main() {
   initialize();
   getValues();
   printCal();
   cexit (0);
}
